import Axios from 'axios'
import TransactionService from './transaction.service'

export default {
  pollJob(config, job) {
    return Axios.get('/api/macfinder/job/' + job, config)
  },
  createJob(config, bcd, mac) {
    return Axios.post('/api/macfinder/job', { bcd: bcd, mac: mac }, config)
  },
  ouiLookup(mac) {
    return Axios.get('/api/macfinder/oui_lookup?mac=' + mac)
  },
  resolveOutlet(config, bcd, device, port) {
    const ta = [
      { name: 'nd.bcd.list', old: { name: bcd } }, // BCDs
      { name: 'nd.vlan.list', inner_join_ref: { bcd_list: 'default' } },
      { name: 'nd.l_port.list', inner_join_ref: { vlan_list: 'default' }, old: { dev_fqdn: device } },
      { name: 'nd.l2p_port.list', inner_join_ref: { l_port_list: 'default' } },
      { name: 'nd.p_port.list', inner_join_ref: { l2p_port_list: 'default' }, old: { name: port } },
      { idx: 'resolved', name: 'nd.p_port.list', old: { sorting_params_list: ['connection_position DESC'] }, inner_join_ref: { 4: 'api_func_nd_p_port_is_intersect_of_conn_node_set'} }
    ]
    return TransactionService.execute(config, ta)
  }
}
