import TransactionService from './transaction.service'

export default {
  getVLANs(config) {
    const ta = [
      { name: 'nd.bcd.list', old: { is_own: true, sorting_params_list: ['name'] } },
      { name: 'nd.vlan.list', inner_join_ref: { bcd_list: 'default' } }
    ]
    return TransactionService.execute(config, ta)
  },
  getLports(config, vlan) {
    const ta = [
      { name: 'nd.vlan.list', old: { global_pk: vlan.global_pk, fetch_limit: 1 } },
      { name: 'nd.vlan_egress.list', inner_join_ref: { vlan_list: 'default' } },
      { name: 'nd.l_port.list', inner_join_ref: { vlan_egress_list: 'default' } },
      { name: 'nd.l2p_port.list', inner_join_ref: { l_port_list: 'default' } },
      { name: 'nd.p_port.list', inner_join_ref: { l2p_port_list: 'default' } }
    ]
    return TransactionService.execute(config, ta)
  }
}
