import TransactionService from './transaction.service'

export default {
  getOU(config, ou) {
    const ta = [
      { idx: 'parent_ou', name: 'org.unit.list', old: { short_name: ou } },
      { name: 'org.unit.list', inner_join_ref: { parent_ou: 'api_func_org_unit_is_superset_of_root_node_set' } },
      { name: 'cntl.mgr2ou.list', inner_join_ref: { parent_ou: 'default' } },
      { name: 'cntl.mgr.list', inner_join_ref: { mgr2ou_list: 'default' } },
      { name: 'dns.fqdn2ou.list', inner_join_ref: { parent_ou: 'default' } },
      { name: 'nd.bcd2ou.list', inner_join_ref: { parent_ou: 'default' } },
      { name: 'nd.bcd.list', inner_join_ref: { bcd2ou_list: 'default' } },
      {
        name: 'cntl.group.list',
        inner_join_ref: { unit_list: 'default' },
        old: { sorting_params_list: ['name'] }
      },
      { name: 'org.unit_type.list', inner_join_ref: { parent_ou: 'default' } }
    ]
    return TransactionService.execute(config, ta)
  },
  listOwn(config) {
    const ta = [
      { idx: 'own_mgr2ou_list', name: 'cntl.mgr2ou.list', old: { is_own: true } },
      {
        name: 'org.unit.list',
        inner_join_ref: { own_mgr2ou_list: 'default' },
        old: { sorting_params_list: ['sub_position'] }
      },
      {
        idx: 'unit_list_superset',
        name: 'org.unit.list',
        inner_join_ref: { unit_list: 'api_func_org_unit_is_superset_of_root_node_set' }
      },
      { name: 'cntl.mgr2ou.list', inner_join_ref: { unit_list_superset: 'default' } },
      { name: 'cntl.mgr.list', inner_join_ref: { mgr2ou_list: 'default' } },
      { name: 'dns.fqdn2ou.list', inner_join_ref: { unit_list_superset: 'default' } },
      { name: 'nd.bcd2ou.list', inner_join_ref: { unit_list_superset: 'default' } },
      { name: 'nd.bcd.list', inner_join_ref: { bcd2ou_list: 'default' } },
      { name: 'org.unit_type.list', inner_join_ref: { unit_list: 'default' } }
    ]
    return TransactionService.execute(config, ta)
  },
  listAll(config) {
    const ta = [
      {
        name: 'org.unit.list',
        old: { sorting_params_list: ['sub_position'] }
      },
      { name: 'cntl.mgr2ou.list', inner_join_ref: { unit_list: 'default' } },
      { name: 'cntl.mgr.list', inner_join_ref: { mgr2ou_list: 'default' } },
      { name: 'dns.fqdn2ou.list', inner_join_ref: { unit_list: 'default' } },
      { name: 'nd.bcd2ou.list', inner_join_ref: { unit_list: 'default' } },
      { name: 'nd.bcd.list', inner_join_ref: { bcd2ou_list: 'default' } },
      { name: 'org.unit_type.list', inner_join_ref: { unit_list: 'default' } }
    ]
    return TransactionService.execute(config, ta)
  }
}
