import Axios from 'axios'
import config from '@/../netvs.config'
import Transactionutil from '@/util/transactionutil'

const RESOURCE_NAME_TA = `${config.NETDB_API_BASE_URL}/wapi/transaction/execute`

export default {
  execute(config, ta) {
    config.headers['Content-Type'] = 'application/json; charset=utf-8'
    return Axios.post(RESOURCE_NAME_TA + '?dict_mode=true', Transactionutil.dictifyTa(ta), config)
  },
  executeList(config, ta) {
    config.headers['Content-Type'] = 'application/json; charset=utf-8'
    return Axios.post(RESOURCE_NAME_TA + '?dict_mode=false', ta, config)
  },
  executeDry(config, ta) {
    config.headers['Content-Type'] = 'application/json; charset=utf-8'
    return Axios.post(RESOURCE_NAME_TA + '?dict_mode=true&dry_mode=true', ta, config)
  },
  executeDrySu(config, ta, user) {
    config.headers['Content-Type'] = 'application/json; charset=utf-8'
    return Axios.post(RESOURCE_NAME_TA + '?dict_mode=true&su_login_name=' + user, ta, config)
  }
}
