export default {
  parse_date(input, format) {
    format = format || 'YYYY-MM-DD hh:mm:ss.ms'
    const parts = input.match(/(\d+)/g)
    let i = 0
    const fmt = {}
    format.replace(/(YYYY|DD|MM|hh|mm|ss|ms)/g, (part) => {
      fmt[part] = i++
    })
    return new Date(parts[fmt.YYYY], parts[fmt.MM] - 1, parts[fmt.DD], parts[fmt.hh], parts[fmt.mm], parts[fmt.ss], parts[fmt.ms])
  },
  format_date(date) {
    return date.getUTCFullYear() + '-' + String(date.getUTCMonth() + 1).padStart(2, '0') + '-' +
      String(date.getUTCDate()).padStart(2, '0') + ' ' + String(date.getUTCHours()).padStart(2, '0') +
      ':' + String(date.getUTCMinutes()).padStart(2, '0') + ':' + String(date.getUTCSeconds()).padStart(2, '0') + ' (UTC)'
  }
}
