import requests
from flask import Blueprint

from net_suite import app, get_git_version, ModMetaData

# we are assuming, that at the time of loading the app is initializes and the config is loaded
bb_name = 'macfinder'
macfinder = Blueprint(bb_name, __name__, template_folder='templates')
app.logger.info('Loading OUI databse...')
OUI_DB = dict()
for oui in ['http://standards-oui.ieee.org/oui.txt', 'https://standards-oui.ieee.org/oui28/mam.txt',
            'https://standards-oui.ieee.org/oui36/oui36.txt']:
    ouis = requests.get(oui).text.split('\n')
    last_hex = ''
    for line in ouis:
        if '(hex)' not in line:
            if '(base 16)' in line:
                p16 = line.split('(base 16)')
                p16[0] = p16[0].strip()
                if '-' in p16[0]:
                    r = [int(p, base=16) for p in p16[0].split('-')]
                    OUI_DB[last_hex].append((r[0], r[1], p16[1].strip()))
            continue
        parts = line.split('(hex)')
        parts[0] = parts[0].strip().lower().replace('-', ':')
        last_hex = parts[0]
        if parts[0] not in OUI_DB:
            OUI_DB[parts[0]] = [(None, None, parts[1].strip())]
        else:
            OUI_DB[parts[0]].append((None, None, parts[1].strip()))

METADATA = ModMetaData(name=bb_name, mod_path=__name__,
                       gitlab_url='https://git.scc.kit.edu/scc-net/net-suite/net-suite-macfinder',
                       printable_name='MACFinder', version=get_git_version(__file__),
                       contact_email='dns-betrieb@scc.kit.edu')
from . import views
